"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TouchTransition = exports.PointerTransition = exports.MouseTransition = exports.HTML5DragTransition = void 0;

var _createTransition = require("./createTransition");

const TouchTransition = (0, _createTransition.createTransition)('touchstart', rawEvent => {
  const event = rawEvent;
  return event.touches !== null && event.touches !== undefined;
});
exports.TouchTransition = TouchTransition;
const HTML5DragTransition = (0, _createTransition.createTransition)('dragstart', event => {
  return event.type.indexOf('drag') !== -1 || event.type.indexOf('drop') !== -1;
});
exports.HTML5DragTransition = HTML5DragTransition;
const MouseTransition = (0, _createTransition.createTransition)('mousedown', event => {
  return event.type.indexOf('touch') === -1 && event.type.indexOf('mouse') !== -1;
});
exports.MouseTransition = MouseTransition;
const PointerTransition = (0, _createTransition.createTransition)('pointerdown', rawEvent => {
  const event = rawEvent;
  return event.pointerType == 'mouse';
});
exports.PointerTransition = PointerTransition;